<?php

declare(strict_types=1);

namespace App\Service;

use App\Repository\TblNivelEducativoRepository;

final class TblNivelEducativoService
{
    private TblNivelEducativoRepository $TblNivelEducativoRepository;

    public function __construct(TblNivelEducativoRepository $TblNivelEducativoRepository)
    {
        $this->TblNivelEducativoRepository = $TblNivelEducativoRepository;
    }

    public function checkAndGet(int $TblNivelEducativoId): object
    {
        return $this->TblNivelEducativoRepository->checkAndGet($TblNivelEducativoId);
    }

    public function getAll(): array
    {
        return $this->TblNivelEducativoRepository->getAll();
    }

    public function getOne(int $TblNivelEducativoId): object
    {
        return $this->checkAndGet($TblNivelEducativoId);
    }

    public function create(array $input): object
    {
        $TblNivelEducativo = json_decode((string) json_encode($input), false);

        return $this->TblNivelEducativoRepository->create($TblNivelEducativo);
    }

    public function update(array $input, int $TblNivelEducativoId): object
    {
        $TblNivelEducativo = $this->checkAndGet($TblNivelEducativoId);
        $data = json_decode((string) json_encode($input), false);

        return $this->TblNivelEducativoRepository->update($TblNivelEducativo, $data);
    }

    public function delete(int $TblNivelEducativoId): void
    {
        $this->checkAndGet($TblNivelEducativoId);
        $this->TblNivelEducativoRepository->delete($TblNivelEducativoId);
    }
}
